Summary:        Kernel and Hardware related utilities
Name:           kernel-utils
Version:        2.4
Release:	8.37.14.XOS.1
Serial:         1
Group:          System Environment/Base
License:        GPL
Url:            http://www.urbanmyth.org/microcode/

%define logdir /var/log

Source0:        microcode_ctl-1.12.tar.gz
Source1:	microcode_ctl.init
Source10:	dmidecode-2.2.tar.gz
Source20: 	smartmontools-5.1-11.tar.gz
Source30:	smartd.conf
Source50:	x86info-1.13.tgz
Source60:	longrun-0.9.tar.bz2
Source90:	irqbalance-0.10.tar.gz
Source91:	irqbalance.init
Source92:	irqbalance.sysconfig
Source100:      salinfo-0.5.tar.gz
Buildroot:      %{_tmppath}/%{name}-%{version}-root
Prereq:		/sbin/chkconfig /sbin/service
Requires:	fileutils
BuildPreReq: 	readline-devel ncurses-devel /usr/bin/aclocal /usr/bin/automake /usr/bin/autoconf
%ifarch {ix86}
Obsoletes:	microcode_ctl
%endif
Patch1: microcode_ctl.patch
Patch2: smartmontools-smartd.patch
Patch3: dmidecode.patch
Patch4: dmidecode-2.2-signedness.patch

%define dmiarchs i386 x86_64

%description
kernel-utils contains several utilities that can be used to control
the kernel or your machines hardware. Included are
* dmidecode - gives information about the bios and motherboard revisisons
* microcode_ctl - updates the microcode on Intel cpu's
* smartctl - monitor the health of your disks


%prep
%setup -q -c -a 0 -a10 -a 20 -a 50 -a60 -a90 -a100

# Small fix to microcode_ctl to dereference ucode buffer correctly
%patch1

%patch2 -p0

# Fix to dmidecode to always turn on IA64 fixes when built on/for IA64.
%patch3

%patch4 -p1

%build
rm -rf $RPM_BUILD_ROOT

mkdir -p %{buildroot}/usr/sbin
mkdir -p %{buildroot}/usr/man
mkdir -p %{buildroot}/etc/rc.d/init.d
mkdir -p %{buildroot}/etc/sysconfig

%ifarch %{ix86} x86_64
cd microcode_ctl-1.12
make CFLAGS="$RPM_OPT_FLAGS"
cd ..
%endif

cd dmidecode-2.2
make
cd ..

%ifarch ia64
cd salinfo-0.5
make
cd ..
%endif

%install
mkdir -p %{buildroot}/usr/share/man/man{1,8}


%ifarch %{ix86} x86_64
cd microcode_ctl-1.12

make DESTDIR=$RPM_BUILD_ROOT PREFIX=%{_prefix} \
     INSDIR=/sbin MANDIR=%{_mandir}/man8 RCDIR=/etc MICDIR=/etc/firmware install clean

install %{SOURCE1} %{buildroot}/etc/rc.d/init.d/microcode_ctl
rm %{buildroot}/etc/init.d/microcode_ctl
cd ..
%endif

%ifarch %{ix86}
cd x86info-1.13
make
install x86info %{buildroot}/usr/sbin/x86info
install  x86info.1 %{buildroot}/usr/share/man/man1/

cd ../longrun
make
install longrun %{buildroot}/usr/sbin
install longrun.1 %{buildroot}/usr/share/man/man1
cd ..
%endif

cd smartmontools-5.1-11
make DESTDIR=$RPM_BUILD_ROOT smartd smartctl install
cp %{SOURCE30} %{buildroot}/etc/smartd.conf

cd ../irqbalance
make
install irqbalance  %{buildroot}/usr/sbin
install %{SOURCE91} %{buildroot}/etc/rc.d/init.d/irqbalance
install %{SOURCE92} %{buildroot}/etc/sysconfig/irqbalance
install irqbalance.1 %{buildroot}/usr/share/man/man1/

cd ../dmidecode-2.2
%ifarch %{dmiarchs}
install dmidecode %{buildroot}/usr/sbin
%endif

%ifarch ia64
cd ../salinfo-0.5
make install prefix=%{buildroot} mandir=%{_mandir} sbindir=%{_sbindir} initdir=%{_sysconfdir}/rc.d/init.d logdir=%{logdir}/salinfo
%endif

chmod -R a-s %{buildroot}
%clean
[ "$RPM_BUILD_ROOT" != "/" ] && [ -d $RPM_BUILD_ROOT ] && rm -rf $RPM_BUILD_ROOT;

%files
%defattr(-,root,root)
%ifarch %{ix86} x86_64
/etc/rc.d/init.d/microcode_ctl
/etc/firmware/*
/sbin/microcode_ctl
%endif
%ifarch %{ix86}
/usr/sbin/x86info
/usr/sbin/longrun
%endif
/usr/sbin/irqbalance
%{_mandir}/*/*
/usr/sbin/smartd
/usr/sbin/smartctl
/etc/rc.d/init.d/smartd
/etc/rc.d/init.d/irqbalance
/etc/sysconfig/irqbalance
%ifarch %{dmiarchs}
/usr/sbin/dmidecode
%endif
%doc /usr/share/doc/smartmontools-5.1
%config /etc/smartd.conf
%ifarch ia64
%doc %{_mandir}/man8/salinfo_decode.8.gz
%{_sbindir}/salinfod
%{_sbindir}/salinfo_decode2
%{_sbindir}/salinfo_decode
%attr(0755,root,root) %{_sysconfdir}/rc.d/init.d/salinfod
%dir %{logdir}/salinfo
%dir %{logdir}/salinfo/raw
%dir %{logdir}/salinfo/decoded
%endif

%preun
if [ "$1" = "0" ] ; then
 /sbin/service smartd stop
 /sbin/chkconfig --del smartd
 /sbin/chkconfig --del irqbalance
%ifarch %{ix86} x86_64
 /sbin/chkconfig --del microcode_ctl
%endif
%ifarch ia64
 /sbin/service salinfod stop
 /sbin/chkconfig --del salinfod
%endif
fi

%post
/sbin/chkconfig --add smartd
/sbin/chkconfig --add irqbalance
%ifarch %{ix86} x86_64
/sbin/chkconfig --add microcode_ctl
%endif
%ifarch ia64
/sbin/chkconfig --add salinfod
%endif

%changelog
* Fri Mar 24 2006 X/OS Linux Team <xoslinux@xos.nl> 1:2.4-8.37.14.XOS.1
- Build for X/OS Linux 3.0.
- X/OS Linux source rpm based on kernel-utils-2.4-8.37.14.src.rpm
  (md5sum of original source rpm: 6effc8608fa325fa90787bf83ac20e86).

* Fri Sep 23 2005 Dave Jones <davej@redhat.com>
- Convert non-ASCII characters to . in dmi_string. (#158990)
- Update microcode_ctl to 1.12 (new ucode). (#165987, #159863)

* Mon Sep 19 2005 Dave Jones <davej@redhat.com>
- Disable dmidecode build on ia64. (#88377)

* Wed Apr  6 2005 Dave Jones <davej@redhat.com>
- Really install the irqbalance manpage (#90023)

* Tue Mar  8 2005 Dave Jones <davej@redhat.com>
- Remove -i flag from microcode_ctl startup. (#150338)

* Fri Feb 25 2005 Dave Jones <davej@redhat.com>
- Update x86info to 1.13.

* Tue Feb 15 2005 Dave Jones <davej@redhat.com>
- Update microcode_ctl to 1.11 (#130916)

* Sun Feb 13 2005 Dave Jones <davej@redhat.com>
- Fix alignment problems when run on IBM eServer xSeries 445 (#112355)

* Sun Nov 28 2004 Dave Jones <davej@redhat.com>
- Don't use binaries from /usr too early. (#102049)
- Fix bogus "" in microcode_ctl initscript. (#112014)

* Fri Oct 29 2004 Dave Jones <davej@redhat.com>
- Update irqbalance (#137136).
- Make irqbalance start by default on x86_64 too (#137508)
- Install irqbalance manpage (#90023)

* Mon Jun 07 2004 Jason Baron <jbaron@redhat.com>
- Add salinfod daemon that reads and decodes machine
  errors on ia64 (Ben Woodard)

* Fri Nov 07 2003 Arjan van de Ven <arjanv@redhat.com>
- update irqbalance

* Mon Sep 08 2003 Arjan van de Ven <arjanv@redhat.com> 2.4.8-36
- update smartmontools to a 64 bit clean version
- update irqbalance

* Thu Aug 21 2003 Arjan van de Ven <arjanv@redhat.com> 2.4.8-35
- update dmidecode

* Tue Jul 29 2003 Arjan van de Ven <arjanv@redhat.com> 2.4-8.33
- disable smartd by default

* Thu Jul 03 2003 Arjan van de Ven <arjanv@redhat.com>
- clean up the spec a bit
- drop cpqarray monitor; too many dependencies for the use it gets

* Mon Jun 02 2003 Arjan van de Ven <arjanv@redhat.com>
- switch to smartmontools for SMART monitoring

* Fri May 02 2003 Arjan van de Ven <arjanv@redhat.com>
- add chstk for setting non-exec stack flags

* Wed Jan 22 2003 Michael K. Johnson <johnsonm@redhat.com> 2.4-8.28
- /etc/sysconfig/irqbalance to set --oneshot from config file

* Sun Jan 19 2003 Arjan van de Ven <arjanv@redhat.com> 2.4-8.26
- updated irqbalance code

* Sat Jan 18 2003 Arjan van de Ven <arjanv@redhat.com> 2.4-8.23
- add initial irqbalance code

* Thu Jan 16 2003 Bill Nottingham <notting@redhat.com> 2.4-8.22
- fix %%post/%%preun on non-x86

* Tue Jan  7 2003 Nalin Dahyabhai <nalin@redhat.com> 2.4-8.21
- Rebuild

* Fri Dec 13 2002 Elliot Lee <sopwith@redhat.com> 2.4-8.20
- Build on all archs

* Thu Dec 12 2002 Michael K. Johnson <johnsonm@redhat.com> 2.4-8.19
- added report-acpi-bug script

* Tue Dec 03 2002 Arjan van de Ven <arjanv@redhat.com> 2.4-8.18
- update x86info to version 1.11
- include pmtools for acpi disasm

* Fri Nov 15 2002 Michael K. Johnson <johnsonm@redhat.com> 2.4-8.17
- HP hasn't said it is shipping hammer, so no need for cpqarrayd on hammer
- uml is x86-only for now -- should probably move to its own package
- deal with new net-snmp additional #include requirements

* Thu Nov 14 2002 Michael K. Johnson <johnsonm@redhat.com> 2.4-8.15
- Added acpidmp for x86 only for now (has x86-specific bits in it)
- Updated package cruft removal

* Thu Sep 12 2002 Guy Streeter <streeter@redhat.com> 2.4-8.14
- No eepro100-diag for ppc.

* Fri Aug 23 2002 Elliot Lee <sopwith@redhat.com> 2.4-8.13
- Don't cop out of building uml_net on ia64 - instead, remove usage of
  (effect-free) SA_NOCLDWAIT if not defined.
- Include all the uml tools (+ jailtest/uml_moo/uml_switch/uml_watchdog)

* Fri Aug 23 2002 Arjan van de Ven <arjanv@redhat.com> 2.4-8.12
- add uml tools

* Wed Aug 21 2002 Elliot Lee <sopwith@redhat.com> 2.4-8.11
- Remove ExclusiveArch: i386 (since it builds everywhere)
- Include smartd/smartctl man pages

* Wed Jul 31 2002 Arjan van de Ven <arjanv@redhat.com>
- added longrun uitility

* Thu Jun 27 2002 Elliot Lee <sopwith@redhat.com> 2.4-8.7
- Patch31 for net-snmp 

* Fri Jun 21 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Thu Jun 20 2002 Michael K. Johnson <johnsonm@redhat.com>
- include the man pages

* Sat Mar 30 2002	Arjan van de Ven <arjanv@redhat.com>
- change initorder to not shut services down after NFS has shut down
  to allow /usr to be NFS mounted

* Wed Mar 20 2002	Arjan van de Ven <arjanv@redhat.com>
- fix microcode_ctl to work on smp

* Thu Mar 14 2002 Bill Nottingham <notting@redhat.com> 2.4-5
- don't run things by default

* Wed Feb  6 2002 Tim Powers <timp@redhat.com> 2.4-3.6.2
- fix %%post sciptlet typo

* Mon Feb 04 2002	Arjan van de Ven <arjanv@redhat.com>
- fail gracefully in microcode_ctl if firmware isn't downloaded

* Mon Jan 28 2002	Arjan van de Ven <arjanv@redhat.com>
- added x86info

* Tue Jan 15 2002       Bill Nottingham <notting@redhat.com>
- move eepro100-diag from kudzu to here

* Fri Jan 11 2002	Arjan van de Ven <arjanv@redhat.com>
- added cpqarrayd for monitoring cpqarray drives too
  from http://starbreeze.knoware.nl/~hugo/compaq/

* Mon Jan 07 2002	Arjan van de Ven <arjanv@redhat.com>
- added smartsuite for monitoring disk health status

* Fri Dec 07 2001	Arjan van de Ven <arjanv@redhat.com>
- Initial packaging
